"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var React = _interopRequireWildcard(require("react"));

var _state = require("@codemirror/state");

var _view = require("@codemirror/view");

var _mergeRefs = require("./merge-refs");

var _excluded = ["value", "onUpdate", "extensions"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var CodeMirror = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var value = _ref.value,
      onUpdate = _ref.onUpdate,
      _ref$extensions = _ref.extensions,
      passedExtensions = _ref$extensions === void 0 ? [] : _ref$extensions,
      props = (0, _objectWithoutProperties2["default"])(_ref, _excluded);
  var innerRef = React.useRef(null);
  var mergedRef = (0, _mergeRefs.useMergeRefs)(ref, innerRef);
  React.useEffect(function () {
    var currentEditor = innerRef.current;
    if (!currentEditor) return;
    var view;
    (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
      var extensions, state;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              extensions = [];
              if (onUpdate) extensions.push(_view.EditorView.updateListener.of(onUpdate));
              state = _state.EditorState.create({
                doc: value,
                extensions: [].concat(extensions, (0, _toConsumableArray2["default"])(passedExtensions))
              });
              view = new _view.EditorView({
                state: state,
                parent: currentEditor
              });

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }))();
    return function () {
      return view.destroy();
    };
  }, [innerRef]);
  return /*#__PURE__*/React.createElement("div", (0, _extends2["default"])({
    ref: mergedRef
  }, props));
});
CodeMirror.displayName = 'CodeMirror';
var _default = CodeMirror;
exports["default"] = _default;