"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useMergeRefs = useMergeRefs;

var _react = _interopRequireDefault(require("react"));

// credit: https://github.com/JakeGinnivan/merge-refs-hook
function setRefs(ref, value) {
  if (typeof ref === 'function') {
    ref(value);
  } else if (ref) {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    ;
    ref.current = value;
  }
}

function useMergeRefs(forwardedRef, localRef) {
  return _react["default"].useCallback(function (value) {
    setRefs(forwardedRef, value);
    setRefs(localRef, value);
  }, [forwardedRef, localRef]);
}